#!/bin/bash

#定义个随机生成数字函数
function rand()
{
    min=$1
    max=$(($2-$min+1))
    num=$(($RANDOM+1000000000))
    echo $(($num%$max+$min))
}
echo " .......setup begin....... "
echo " .......install necessary soft....... "
# 安装PIP
sudo apt-get update
sudo apt-get install python-pip
sudo apt-get install python-setuptools m2crypto

# 安装shadowsocks
pip install shadowsocks

echo " .......install soft finish ......."
echo " .......creating config ......."

# 随机端口和密码：
port="100"$(rand 10 50)
password="qaz"$(rand 100 999)"plm"

#获取本地ip
ip_string=`ifconfig -a|grep inet|grep -v 127.0.0.1|grep -v inet6|awk '{print $2}'|tr -d "addr:"`
shadowsocks_path="/etc/shadowsocks.json"

echo "{
    \"server\":\""$ip_string"\",
    \"local_address\": \"127.0.0.1\",
    \"local_port\":1080,
    \"timeout\":300,
    \"port_password\":{
        \""$port"\":\""$password"\"
    },
    \"method\":\"rc4-md5\",
    \"timeout\":300
}" > $shadowsocks_path



#创建 start_ss.sh，写入：
echo "ssserver -c "$shadowsocks_path" -d start" > ~/start_ss.sh

#创建 stop_ss.sh，写入：
echo "ssserver -c "$shadowsocks_path" -d stop" > ~/stop_ss.sh

#创建 restart_ss.sh，写入：
echo "ssserver -c "$shadowsocks_path" -d stop
      ssserver -c "$shadowsocks_path" -d start" > ~/restart_ss.sh

# 设置脚本权限
chmod +x ~/*_ss.sh

echo " .......setup begin ......."
~/restart_ss.sh
echo ""
echo ""
echo "shadowsocks server ip:"$ip_string", port:"$port", password:"$password", method:rc4-md5"
